app/Http/routes.php
<?php

Route::get('/', [
    'as' => 'home',
    'uses' => 'PagesController@index'
]);

Route::get('/dashboard', [
    'as' => 'dashboard',
    'middleware' => 'auth',
    'uses' => 'DashboardController@index'
]);



Route::group(['prefix' => 'api'], function() {

    /*
     * JWT-protected Routes
    */
    Route::group(['middleware' => 'api'], function() {

        Route::get('/rate', [
            'as' => 'api.rates',
            'uses' => 'RatesController@calculate'
        ]);
        
    });

    Route::post('auth/token', 'JWTController@postToken');
    Route::get('auth/token', 'JWTController@token');

    //individual api endpoints
    Route::get('remove-country-group', [
        'as' => 'api.remove-country-group',
        'uses' => 'AdminController@removeCountryGroup'
    ]);

});

Route::group(['prefix' => 'admin', 'middleware' => 'auth'], function() {

    Route::resource('tokens', 'TokensController', ['except' => 'show']);
    Route::resource('countries', 'CountriesController', ['except' => 'show']);
    Route::resource('groups', 'GroupsController', ['except' => 'show']);
    Route::resource('rates', 'RatesController', ['only' => ['edit', 'update']]);

    //Single Routes
    Route::get('/', [
        'as' => 'admin.index',
        'uses' => 'AdminController@index'
    ]);
    Route::post('add-country-group', [
        'as' => 'admin.add-country-group',
        'uses' => 'CountryGroupController@postAdd'
    ]);

});

Route::auth();

app/Token.php
<?php

namespace App;

use App\BaseModel;
use \Carbon\Carbon;
use \Firebase\JWT\JWT;

class Token extends BaseModel
{
    protected $fillable = ['user_id'];
    protected $rules = [
        'user_id' => 'required',
        'jwt' => 'required'
    ];

    public static function issue($user)
    {   
        $token = new self();
        $secret = env('APP_KEY');
        $exp = $token->exp();

        $token->user_id = $user->id;
        $token->expiration = $exp;
        $token->jwt = JWT::encode([
            'userId' => $user->id
        ], $secret);
        
        $token->save();

        return $token;
    }

    public function expirationHuman()
    {
        $exp = Carbon::createFromTimestamp($this->expiration);
        return $exp->diffForHumans();
    }

    public function exp()
    {
        $now = Carbon::now();

        return $now->addDays(30)->timestamp;
    }

    public function user()
    {
        return $this->belongsTo('App\User');
    }
}

app/Http/Controllers/TokensController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Http\Requests;
use \Firebase\JWT\JWT;
use App\Token;
use App\User;

class TokensController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $now = time();
        $tokens = Token::where('expiration', '>=', $now)
            ->orderBy('expiration', 'DESC')
            ->paginate(20);

        return view('admin.tokens.index', [
            'tokens' => $tokens
        ]);
    }

    /**
     * Show the form for creating a new resource.
     
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $users = User::where('active', true)->get();
        return view('admin.tokens.create', [
            'users' => $users
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        try {
            $user = User::find($request->input('user_id', null));
            
            Token::issue($user);

            return redirect()
                ->route('admin.tokens.index')
                ->with('flash', [
                    'type' => 'success',
                    'message' => trans('forms.messages.success')
                ]);

        } catch(\Illuminate\Database\Eloquent\ModelNotFoundException $e) {
            return redirect()
                ->route('admin.tokens.index')
                ->with('flash', [
                    'type' => 'error',
                    'message' => trans('forms.messages.not_found')
                ]);
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        Token::destroy($id);
        return response()->json(1);
    }
}

resources/views/admin/tokens/create.blade.php
@extends('layouts.master')

@section('title', trans('site.page_titles.admin.tokens'))

@section('content')
<div class="row">
    <div class="col s6 offset-s3">
        <form method="post" action="{{ route('admin.tokens.store') }}">
            <div class="row">
                <div class="col s12">
                    <h2>{{ trans('site.headers.admin.add', ['type' => 'Token']) }}</h2>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <select name="user_id">
                      <option value="" disabled selected>Choose User</option>
                       @foreach($users as $user)
                            <option value="{{ $user->id }}">{{ $user->politeName() }}</option>
                        @endforeach
                    </select>
                </div>
            </div>
            <div class="row">
                <div class="col s12">
                    <div class="input-field">
                        {!! csrf_field() !!}
                        <button type="submit" class="waves-effect waves-light black btn">{{ trans('site.forms.actions.create_type', ['type' => 'Token']) }}</button>
                        <a href="{{ route('admin.tokens.index') }}" class="waves-effect waves-teal btn-flat">{{ trans('site.actions.cancel') }}</a>
                    </div>
                </div>
            </div>
        </form>
    </div>
</div>
@endsection

resources/views/admin/tokens/index.blade.php
@extends('layouts.master')

@section('title', trans('site.page_titles.admin.tokens'))

@section('content')
<div class="container">
    @include('elements.flash')
    <h1>{{ trans('site.headers.admin.tokens') }}</h1>
    <table class="striped bordered">
        <thead>
            <tr>
                <th class="id">{{ trans('site.tables.headers.id') }}</th>
                <th>{{ trans('site.tables.headers.user') }}</th>
                <th>{{ trans('site.tables.headers.expiration') }}</th>
                <th>{{ trans('site.tables.headers.jwt') }}</th>
                <th class="action">
                    <a href="{{ route('admin.tokens.create') }}" class="btn-floating btn-small waves-effect waves-light green"><i class="material-icons">add</i>
                    </a>
                </th>
            </tr>
        </thead>
        <tbody>
            @forelse($tokens as $token)
                <tr>
                    <td class="id">{{ $token->id }}</td>
                    <td>{{ $token->user->politeName() }}</td>
                    <td>{{ $token->expirationHuman() }}</td>
                    <td class="text-center"><a href="#token{{ $token->id }}" class="modal-trigger"><i class="material-icons">open_in_new</i></a></td>
                    <td class="action">    
                        <a href="{{ route('admin.tokens.destroy', ['id' => $token->id]) }}" onClick="javascript: return window.confirm('Are you sure?');" type="submit" class="btn-floating btn-small waves-effect waves-light red delete-token"><i class="material-icons">delete_forever</i></a>
                        <a href="{{ route('admin.tokens.destroy', ['id' => $token->id]) }}" class="waves-effect waves-teal btn-flat"><i class="material-icons">delete</i></a>
                    </td>            
                </tr>
            @empty
                <tr>
                    <td colspan="4">
                        No Tokens Issued
                    </td>
                </tr>
            @endforelse
        </tbody>
    </table>
    <div class="text-right">
        @include('elements.pagination', ['p' => $tokens])
    </div>
</div>
@foreach($tokens as $token)
<!-- Modal Structure -->
<div id="token{{ $token->id }}" class="modal">
    <div class="modal-content">
        <h4>JWT</h4>
        <p class="break">{{ $token->jwt }}</p>
    </div>
</div>
@endforeach

@endsection